'Gewitterwarner 2 mit reduzierter Taktfrequenz, Levelbegrenzung und AGC-Dynamisierung

$regfile = "attiny13.dat"
$crystal = 128000                                           'Taktfrequenz
$hwstack = 16
$swstack = 16
$framesize = 16

'Config Adc = Single , Prescaler = 2 , Reference = Avcc      ' Pre 8...32
'Start Adc
'Open "comb.1:9600,8,n,1,INVERTED" For Output As #1
'Open "comb.2:9600,8,n,1,INVERTED" For Input As #2

Config Portb = &B00011101

Config Timer0 = Pwm , Prescale = 1 , Compare A Pwm = Clear Up       'PWM B0
Start Timer0

Config Int0 = Rising                                        'INT0 B1
On Int0 Isrint0
Enable Int0

Dim I As Byte
Dim J As Byte
Dim Count As Word
Dim Level As Word
Dim Decay As Word


Count = 0
I = 0
Portb.2 = 1
Do
  I = I + 1
  Pwm0a = I
  Enable Interrupts
  Waitms 50
  Disable Interrupts
Loop Until Count > 200                                      'Ub einstellen
Portb.2 = 0
Shift I , Right                                             'durch 2
J = I
Shift J , Right , 2
J = J + I                                                   'PWM=62,5%
Pwm0a = J
Wait 2
Level = 255

Do
  Count = 0
  Enable Interrupts
  Waitms 1000                                               '1 s zhlen
  Disable Interrupts
  If Count > 32 Then                                         'min 2 Impulse
    Level = Level + Count                                   'Count
    Portb.3 = 1                                             'Blitz-LED B2
    Waitms 20
    Portb.3 = 0
    Waitms 20
  End If
  Decay = Level
  Shift Decay , Right , 8
  Level = Level - Decay                                     'Level nimmt ab

  If Level < 1000 Then Pwm0a = J                            'PWM=62,5%
  If Level < 2000 Then Portb = &B00000000
  If Level > 2000 Then Portb = &B00001000                   'grn
  If Level > 3000 Then Pwm0a = I                            'PWM=50%
  If Level > 4000 Then Portb = &B00010000                   'gelb
  If Level > 6000 Then Portb = &B00000100                   'rot
  If Level > 7000 Then Level = 7000                         'Levelbegrenzung
  If Decay = 0 Then                                         'Nix zu tun
   Enable Interrupts
   Idle
  End If

Loop

Isrint0:
 Count = Count + 32                                         'Software-Counter
 If Count > 250 Then Count = 250
Return

End